var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define("constants", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    // Graphics constants
    exports.HP_TEXT_FONT = "20px Arial";
    exports.CARD_REGEX_TEXT_FONT = "18px monospace";
    exports.CARD_PASSWORD_TEXT_FONT = "18px monospace";
    exports.CARD_SELECTION_TEXT_FONT = "20px Arial";
    exports.CARD_DAMAGE_TEXT_FONT = "25px Arial";
    exports.REGEX_STRING_TEXT_FONT = "20px monospace";
    exports.SKIP_TURN_FONT = "20px Arial";
    exports.BORDER_SIZE = 8;
    // Game constants
    exports.PLAYER_COUNT = 2;
    exports.FIRST_PLAYER = 0;
    exports.SECOND_PLAYER = 1;
    exports.START_HP = 20;
    exports.GAME_FIELD_Y = -130;
    var GamePhase;
    (function (GamePhase) {
        GamePhase[GamePhase["Changing"] = 0] = "Changing";
        GamePhase[GamePhase["Matching"] = 1] = "Matching";
    })(GamePhase = exports.GamePhase || (exports.GamePhase = {}));
    ;
});
define("utils", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function randomInt(lower, upper) {
        return lower + Math.floor(Math.random() * (upper - lower + 1));
    }
    exports.randomInt = randomInt;
    function randomIntExclusive(lower, upper) {
        return lower + Math.floor(Math.random() * (upper - lower));
    }
    exports.randomIntExclusive = randomIntExclusive;
    function randomIndex(size) {
        return Math.floor(Math.random() * size);
    }
    exports.randomIndex = randomIndex;
    function clone_object(object) {
        return JSON.parse(JSON.stringify(object));
    }
    exports.clone_object = clone_object;
    function is_regex_valid(regex) {
        try {
            new RegExp(regex, "g");
            return true;
        }
        catch (e) {
            return false;
        }
    }
    exports.is_regex_valid = is_regex_valid;
    function get_max_match(regex, password) {
        var matches = password.match(new RegExp(regex, "g"));
        var max_match = "";
        if (matches) {
            for (var _i = 0, matches_1 = matches; _i < matches_1.length; _i++) {
                var match = matches_1[_i];
                if (match.length > max_match.length) {
                    max_match = match;
                }
            }
        }
        return max_match;
    }
    exports.get_max_match = get_max_match;
    function oppositePlayer(player) {
        return 1 - player;
    }
    exports.oppositePlayer = oppositePlayer;
});
define("decks", ["require", "exports", "utils"], function (require, exports, utils_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var CARD_COUNT = 30;
    var CardSpec = /** @class */ (function () {
        function CardSpec(password, regex, image_index, original_key_class) {
            this.password = password;
            this.regex = regex;
            this.image_index = image_index;
            this.original_key_class = original_key_class;
        }
        return CardSpec;
    }());
    exports.CardSpec = CardSpec;
    ;
    var card_indexes = [];
    function draw_random_card_spec(cards) {
        if (card_indexes.length === 0) {
            for (var i = 0; i < cards.length; i++)
                card_indexes.push(i);
        }
        var index_i = utils_1.randomIndex(card_indexes.length);
        var card_i = card_indexes[index_i];
        card_indexes.splice(index_i, 1);
        // HACK.
        cards[card_i].image_index = card_i % CARD_COUNT;
        // cards[card_i].password = "AAAAAAAAAAAA";
        //console.log(`Drawing random card, card_i = ${card_i}, image = ${cards[card_i].image_index}`);
        return cards[card_i];
    }
    exports.draw_random_card_spec = draw_random_card_spec;
    var CardClass;
    (function (CardClass) {
        CardClass[CardClass["Letters"] = 0] = "Letters";
        CardClass[CardClass["Digits"] = 1] = "Digits";
        CardClass[CardClass["Symbols"] = 2] = "Symbols";
        CardClass[CardClass["Modifiers"] = 3] = "Modifiers";
        CardClass[CardClass["Random"] = 4] = "Random";
    })(CardClass = exports.CardClass || (exports.CardClass = {}));
    ;
    function resolve_random_class(card_class, is_password) {
        if (card_class === CardClass.Random) {
            card_class = utils_1.randomIndex(CardClass.Random);
            if (is_password) {
                while (card_class === CardClass.Modifiers) {
                    card_class = utils_1.randomIndex(CardClass.Random);
                }
            }
        }
        return card_class;
    }
    var LETTER_KEY_TEMPLATES = [
        "[A-Z]",
        "[a-z]",
    ];
    var DIGITS_KEY_TEMPLATES = [
        "[0-9]",
        "[0-9]",
        "\\d",
        "\\d",
        "000",
        "111",
    ];
    var SYMBOLS_KEY_TEMPLATES = [
        "[_#@]",
        "[#%!]",
        "[_@!]",
        "[@%!]",
        "[_#@%!]",
        "[_#@!]",
        "[_@%!]",
        ".",
        "\\D",
    ];
    var MODIFIERS_KEY_TEMPLATES = [
        "{1,2}",
        "{2,3}",
        "{4,6}",
        "{1,4}",
        "{5,6}",
        "{2,5}",
        "{6,}"
    ];
    function generate_key(card_class) {
        card_class = resolve_random_class(card_class, false);
        if (card_class === CardClass.Letters) {
            return LETTER_KEY_TEMPLATES[utils_1.randomIndex(LETTER_KEY_TEMPLATES.length)];
        }
        else if (card_class === CardClass.Digits) {
            return DIGITS_KEY_TEMPLATES[utils_1.randomIndex(DIGITS_KEY_TEMPLATES.length)];
        }
        else if (card_class === CardClass.Symbols) {
            return SYMBOLS_KEY_TEMPLATES[utils_1.randomIndex(SYMBOLS_KEY_TEMPLATES.length)];
        }
        else if (card_class === CardClass.Modifiers) {
            return MODIFIERS_KEY_TEMPLATES[utils_1.randomIndex(MODIFIERS_KEY_TEMPLATES.length)];
        }
        console.error("generate_key: unknown card_class");
        return null;
    }
    var LETTER_PASSWORD_TEMPLATES = [
        "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
        "abcdefghijklmnopqrstuvwxyz",
    ];
    var DIGITS_PASSWORD_TEMPLATES = [
        "0123456789",
        "0123456789",
        "0123456789",
        "0",
        "1",
    ];
    var SYMBOLS_PASSWORD_TEMPLATES = [
        "_#@%!",
    ];
    function generate_password(card_class) {
        card_class = resolve_random_class(card_class, true);
        var template;
        var length;
        if (card_class === CardClass.Letters) {
            template = LETTER_PASSWORD_TEMPLATES[utils_1.randomIndex(LETTER_PASSWORD_TEMPLATES.length)];
            length = utils_1.randomInt(3, 4);
        }
        else if (card_class === CardClass.Digits) {
            template = DIGITS_PASSWORD_TEMPLATES[utils_1.randomIndex(DIGITS_PASSWORD_TEMPLATES.length)];
            length = 3;
        }
        else if (card_class === CardClass.Symbols) {
            template = SYMBOLS_PASSWORD_TEMPLATES[utils_1.randomIndex(SYMBOLS_PASSWORD_TEMPLATES.length)];
            length = utils_1.randomInt(2, 3);
        }
        else if (card_class === CardClass.Modifiers) {
            console.error("generate_password: can not use CardClass.Modifiers");
            return null;
        }
        else {
            console.error("generate_password: unknown card_class " + card_class);
            return null;
        }
        var password = "";
        for (var i = 0; i < length; ++i) {
            var index = utils_1.randomIndex(template.length);
            password += template[index];
        }
        return password;
    }
    var CardTemplate = /** @class */ (function () {
        function CardTemplate(id, key_class, password_classes) {
            this.id = id;
            this.key_class = key_class;
            this.password_classes = password_classes;
        }
        return CardTemplate;
    }());
    var CARD_TEMPLATES = [
        new CardTemplate("L00", CardClass.Letters, [CardClass.Random]),
        new CardTemplate("L01", CardClass.Letters, [CardClass.Random, CardClass.Letters]),
        new CardTemplate("L02", CardClass.Letters, [CardClass.Symbols]),
        new CardTemplate("L03", CardClass.Letters, [CardClass.Symbols, CardClass.Letters]),
        new CardTemplate("L04", CardClass.Letters, [CardClass.Digits]),
        new CardTemplate("L04", CardClass.Letters, [CardClass.Digits, CardClass.Letters]),
        new CardTemplate("D00", CardClass.Digits, [CardClass.Random]),
        new CardTemplate("D01", CardClass.Digits, [CardClass.Random, CardClass.Letters]),
        new CardTemplate("D02", CardClass.Digits, [CardClass.Symbols]),
        new CardTemplate("D03", CardClass.Digits, [CardClass.Symbols, CardClass.Letters]),
        new CardTemplate("D04", CardClass.Digits, [CardClass.Letters]),
        new CardTemplate("S00", CardClass.Symbols, [CardClass.Random, CardClass.Random]),
        new CardTemplate("S01", CardClass.Symbols, [CardClass.Random, CardClass.Random]),
        new CardTemplate("M00", CardClass.Modifiers, [CardClass.Letters, CardClass.Letters, CardClass.Letters]),
        new CardTemplate("M01", CardClass.Modifiers, [CardClass.Digits, CardClass.Digits, CardClass.Digits]),
        new CardTemplate("M02", CardClass.Modifiers, [CardClass.Letters, CardClass.Letters, CardClass.Digits]),
        new CardTemplate("M03", CardClass.Modifiers, [CardClass.Digits, CardClass.Digits, CardClass.Letters]),
        new CardTemplate("M04", CardClass.Modifiers, [CardClass.Symbols, CardClass.Letters]),
        new CardTemplate("M05", CardClass.Modifiers, [CardClass.Symbols, CardClass.Digits]),
    ];
    function generate_regex_class_cards() {
        var cards = new Array();
        for (var i = 0; i < CARD_TEMPLATES.length; ++i)
            for (var k = 0; k < 2; k++) {
                var template = CARD_TEMPLATES[i];
                var id = template.id;
                var key = generate_key(template.key_class);
                var password = "";
                for (var j = 0; j < template.password_classes.length; ++j) {
                    var tmp = generate_password(template.password_classes[j]);
                    password += tmp;
                }
                //console.log("new card spec: ", id, key, password);
                cards.push(new CardSpec(password, key, i % CARD_COUNT, template.key_class));
            }
        return cards;
    }
    exports.XKCD_MEME_CARDS = generate_regex_class_cards();
    // [
    //     new CardSpec('Tr0ub4dor&3', '[a-z]'),
    //     new CardSpec('Serious PuTTY', '[a-z]'),
    //     new CardSpec('tumblv3rs3', '[a-z]'),
    //     new CardSpec('i12kissU', '[a-z]'),
    //     new CardSpec('itsasecret', '[a-z]'),
    //     new CardSpec('password', '[A-Z]'),
    //     new CardSpec('******', '[A-Z]'),
    //     new CardSpec('b33sw1tht1r3s', '[A-Z]'),
    //     new CardSpec('Huge ass-box', '[A-Z]'),
    //     new CardSpec('WE RISE', '\\s?[a-uC-E]'),
    //     new CardSpec('DenverCoder9', '\\w'),
    //     new CardSpec('123456789', '\\w'),
    //     new CardSpec('qwerty', '\\d{1,2}'),
    //     new CardSpec('f00tb411', '\\d{1,2}'),
    //     new CardSpec('segF4ULT', '\\d{1,2}'),
    //     new CardSpec('go ham or go home', '.\\d'),
    //     new CardSpec('TH3C4K31S4L13', '.\\d'),
    //     new CardSpec('sTrOnGpAsSwOrD', '\\D{2}'),
    //     new CardSpec('xXxH4XX0RxXx', '\\D{2}'),
    //     new CardSpec('DeepFriedSkittles', '.er'),
    //     new CardSpec('\\\\"\\\'no\\\'\\escape\\"\\', '[oui].'),
    //     new CardSpec('choKoBAnaNA', '(.)\\1+'),
    //     new CardSpec('ilovepuppies', '[aeiou]+'),
    //     new CardSpec('24-06-1985', '[a-n]{1,3}'),
    //     new CardSpec('1337_4_L1F3', '[A-Z]{3,}'),
    //     new CardSpec('hamster ball', '([a-z][A-Z]){1,3}'),
    //     new CardSpec('100 Problems', '.[xkcd].'),
    //     new CardSpec('f**k grapefruit', '[123]{1,3}'),
    //     new CardSpec('fLyingfErret', '\\W{1,4}'),
    //     new CardSpec('MansNotHot', '\\d\\D*\\d')
    // ];
    exports.IPV4 = [
        "163.10.201.43",
        "217.79.198.104",
        "191.134.54.100",
        "99.120.177.211",
        "172.220.254.106"
    ];
});
define("layout", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var DEFAULT_SPACING = 10;
    var LayoutDirection;
    (function (LayoutDirection) {
        LayoutDirection[LayoutDirection["Vertical"] = 0] = "Vertical";
        LayoutDirection[LayoutDirection["Horizontal"] = 1] = "Horizontal";
    })(LayoutDirection = exports.LayoutDirection || (exports.LayoutDirection = {}));
    ;
    var TiledLayout = /** @class */ (function (_super) {
        __extends(TiledLayout, _super);
        function TiledLayout(direction, spacing, center_elements, size) {
            if (center_elements === void 0) { center_elements = false; }
            if (size === void 0) { size = 0; }
            var _this = _super.call(this) || this;
            _this.direction = direction;
            _this.spacing = spacing;
            _this.center_elements = center_elements;
            _this.size = size;
            return _this;
        }
        TiledLayout.prototype.apply_centering = function () {
            for (var _i = 0, _a = this.children; _i < _a.length; _i++) {
                var child = _a[_i];
                if (this.direction === LayoutDirection.Horizontal) {
                    child.y += (this.size - child.getBounds().height) / 2;
                }
                else {
                    child.x += (this.size - child.getBounds().width) / 2;
                }
            }
        };
        TiledLayout.prototype.addItem = function (item, spacing) {
            if (spacing === void 0) { spacing = 0; }
            if (this.numChildren > 0) {
                if (this.direction === LayoutDirection.Horizontal) {
                    item.x += _super.prototype.getBounds.call(this).width + this.spacing + spacing;
                }
                else {
                    item.y += _super.prototype.getBounds.call(this).height + this.spacing + spacing;
                }
            }
            _super.prototype.addChild.call(this, item);
            // TODO: Finish implementing this.
            // if (this.center_elements) {
            //     this.apply_centering();
            // }
        };
        return TiledLayout;
    }(createjs.Container));
    exports.TiledLayout = TiledLayout;
    ;
});
define("player", ["require", "exports", "constants", "card", "layout"], function (require, exports, constants_1, card_1, layout_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function generate_players() {
        var player_states = new Array(2);
        for (var i = 0; i < 2; ++i) {
            player_states[i] = new PlayerState();
        }
        return player_states;
    }
    exports.generate_players = generate_players;
    var Hand = /** @class */ (function () {
        function Hand(cards) {
            this.cards = cards;
            this.container = new layout_1.TiledLayout(layout_1.LayoutDirection.Horizontal, 15);
            for (var i = 0; i < this.cards.length; ++i) {
                this.cards[i].change_state(card_1.CardState.InHand);
                this.container.addItem(this.cards[i].container);
            }
        }
        Hand.prototype.get_selected_for_swap = function () {
            for (var _i = 0, _a = this.cards; _i < _a.length; _i++) {
                var card = _a[_i];
                if (card.selected_for_swap) {
                    return card;
                }
            }
            return null;
        };
        Hand.prototype.change_card = function (old_card, new_card) {
            var index = this.cards.indexOf(old_card);
            this.cards[index] = new_card;
            index = this.container.getChildIndex(old_card.container);
            this.container.removeChildAt(index);
            this.container.addChildAt(new_card.container, index);
            new_card.container.x = old_card.container.x;
            new_card.container.y = old_card.container.y;
            new_card.change_state(card_1.CardState.InHand);
        };
        return Hand;
    }());
    exports.Hand = Hand;
    ;
    var InPlay = /** @class */ (function () {
        function InPlay(cards) {
            this.cards = cards;
            this.container = new layout_1.TiledLayout(layout_1.LayoutDirection.Horizontal, 15);
            for (var i = 0; i < this.cards.length; ++i) {
                this.cards[i].state = card_1.CardState.InPlay;
                this.container.addItem(this.cards[i].container);
            }
        }
        InPlay.prototype.get_selected_for_swap = function () {
            for (var _i = 0, _a = this.cards; _i < _a.length; _i++) {
                var card = _a[_i];
                if (card.selected_for_swap) {
                    return card;
                }
            }
            return null;
        };
        return InPlay;
    }());
    exports.InPlay = InPlay;
    ;
    var PlayerState = /** @class */ (function () {
        function PlayerState() {
            this.hp_text = new createjs.Text("", constants_1.HP_TEXT_FONT, "red");
            this.set_hp(constants_1.START_HP);
            this.container = new createjs.Container();
            this.container.addChild(this.hp_text);
            this.deck = card_1.generate_cards(10);
        }
        PlayerState.prototype.set_hp = function (hp) {
            this.hp = hp;
            this.hp_text.text = "HP: " + this.hp.toString();
        };
        PlayerState.prototype.deal_damage = function (match_length) {
            var damage = match_length;
            this.set_hp(this.hp - damage);
            console.log("Dealed " + damage + " damage, current hp: " + this.hp);
        };
        PlayerState.prototype.pick_card_from_deck = function () {
            // A bit of a hack
            if (this.deck.length == 0) {
                this.deck = card_1.generate_cards(10);
            }
            if (this.deck.length == 0) {
                return null;
            }
            else {
                return this.deck.shift();
            }
        };
        return PlayerState;
    }());
    exports.PlayerState = PlayerState;
    ;
});
define("computer", ["require", "exports", "main", "constants", "card", "utils", "layout"], function (require, exports, main_1, constants_2, card_2, utils_2, layout_2) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var DIFFICULTY_COUNT = 3;
    var Computer = /** @class */ (function () {
        function Computer() {
            var _this = this;
            // console.error("Creating computer");
            this.difficulty_container = new createjs.Container();
            this.difficulties_buttons_on = new Array(DIFFICULTY_COUNT);
            this.difficulties_buttons_off = new Array(DIFFICULTY_COUNT);
            var vertical_on = new layout_2.TiledLayout(layout_2.LayoutDirection.Horizontal, 5);
            var vertical_off = new layout_2.TiledLayout(layout_2.LayoutDirection.Horizontal, 5);
            var _loop_1 = function (i) {
                this_1.difficulties_buttons_on[i] = new createjs.Sprite(main_1.assets.difficulty_button_spritesheet);
                this_1.difficulties_buttons_off[i] = new createjs.Sprite(main_1.assets.difficulty_button_spritesheet);
                var SCALE = 0.6;
                this_1.difficulties_buttons_on[i].setTransform(0, 0, SCALE, SCALE);
                this_1.difficulties_buttons_on[i].gotoAndStop(i);
                this_1.difficulties_buttons_on[i].on("click", function (event) {
                    _this.set_difficulty(i);
                });
                this_1.difficulties_buttons_off[i].gotoAndStop(3 + i);
                this_1.difficulties_buttons_off[i].setTransform(0, 0, SCALE, SCALE);
                vertical_on.addItem(this_1.difficulties_buttons_on[i]);
                vertical_off.addItem(this_1.difficulties_buttons_off[i]);
            };
            var this_1 = this;
            for (var i = 0; i < DIFFICULTY_COUNT; ++i) {
                _loop_1(i);
            }
            this.difficulty_container.addChild(vertical_on);
            this.difficulty_container.addChild(vertical_off);
            this.set_difficulty(1);
        }
        Computer.prototype.set_difficulty = function (difficulty) {
            console.log("Setting difficulty to", difficulty);
            this.difficulty = difficulty;
            for (var i = 0; i < DIFFICULTY_COUNT; ++i) {
                this.difficulties_buttons_on[i].visible = (i !== difficulty);
                this.difficulties_buttons_off[i].visible = (i === difficulty);
            }
        };
        Computer.prototype.play_as_computer = function (game_state) {
            // Give control to computer.
            console.log("Taking lock");
            game_state.computer_thinking = true;
            if (game_state.phase === constants_2.GamePhase.Changing) {
                console.log("Playing change");
                this.play_change(game_state);
            }
            else if (game_state.phase == constants_2.GamePhase.Matching) {
                console.log("Playing match");
                this.play_match(game_state);
            }
        };
        Computer.prototype.finish_play = function (game_state) {
            // Give control back to player.
            console.log("Releasing lock");
            game_state.computer_thinking = false;
        };
        Computer.prototype.play_change = function (game_state) {
            var _this = this;
            var opponent_cards_inplay = game_state.cards_inplay[constants_2.FIRST_PLAYER].cards;
            var my_cards_inplay = game_state.cards_inplay[constants_2.SECOND_PLAYER].cards;
            var my_cards_inhand = game_state.cards_inhand[constants_2.SECOND_PLAYER].cards;
            var in_hand_card = utils_2.randomInt(0, my_cards_inhand.length - 1);
            var in_play_card = utils_2.randomInt(0, my_cards_inplay.length - 1);
            if (this.difficulty >= 1) {
                var max_total_match_length = 0;
                for (var i = 0; i < my_cards_inhand.length; ++i) {
                    var my_card = my_cards_inhand[i];
                    if (!utils_2.is_regex_valid(my_card.regex)) {
                        continue;
                    }
                    var total_match_length = 0;
                    for (var j = 0; j < opponent_cards_inplay.length; ++j) {
                        total_match_length += utils_2.get_max_match(my_card.regex, opponent_cards_inplay[j].password).length;
                    }
                    if (total_match_length >= max_total_match_length) {
                        in_hand_card = i;
                        max_total_match_length = total_match_length;
                    }
                }
            }
            createjs.Tween.get({}).wait(2000).call(function () {
                game_state.select_card(constants_2.SECOND_PLAYER, my_cards_inhand[in_hand_card].id, true);
                game_state.select_card(constants_2.SECOND_PLAYER, my_cards_inplay[in_play_card].id, true);
                _this.finish_play(game_state);
            });
        };
        Computer.prototype.get_depth_from_difficulty = function (difficulty) {
            if (difficulty == 2) {
                return 3;
            }
            return 2;
        };
        Computer.prototype.play_match = function (game_state) {
            var _this = this;
            var opponent_cards = game_state.cards_inplay[constants_2.FIRST_PLAYER].cards;
            var my_cards = game_state.cards_inplay[constants_2.SECOND_PLAYER].cards;
            var Action = /** @class */ (function () {
                function Action(target_card) {
                    this.regex_string = "";
                    this.attack_cards = new Array();
                    this.target_card = target_card;
                }
                return Action;
            }());
            var actions = new Array();
            for (var i = 0; i < opponent_cards.length; ++i) {
                var card = opponent_cards[i];
                if (card.state != card_2.CardState.InPlay) {
                    continue;
                }
                actions.push(new Action(i));
            }
            var MAX_DEPTH = this.get_depth_from_difficulty(this.difficulty);
            var wave_start = 0;
            var wave_finish = actions.length;
            var max_max_match = "";
            var max_max_match_i = 0;
            for (var depth = 0; depth < MAX_DEPTH; ++depth) {
                for (var i = wave_start; i < wave_finish; ++i) {
                    var action_1 = actions[i];
                    for (var j = 0; j < my_cards.length; ++j) {
                        var card = my_cards[j];
                        if (card.state !== card_2.CardState.InPlay) {
                            continue;
                        }
                        if (action_1.attack_cards.indexOf(j) !== -1) {
                            continue;
                        }
                        var regex_string = action_1.regex_string + card.regex;
                        if (!utils_2.is_regex_valid(regex_string)) {
                            continue;
                        }
                        var max_match = utils_2.get_max_match(regex_string, opponent_cards[action_1.target_card].password);
                        if (max_match.length > 0) {
                            var new_action = utils_2.clone_object(action_1);
                            new_action.attack_cards.push(j);
                            new_action.regex_string = regex_string;
                            actions.push(new_action);
                            if (max_match.length > max_max_match.length) {
                                max_max_match = max_match;
                                max_max_match_i = actions.length - 1;
                            }
                        }
                    }
                }
                wave_start = wave_finish;
                wave_finish = actions.length;
            }
            var tween = createjs.Tween.get({}).wait(1500);
            console.log("Found " + actions.length + " actions");
            console.log(actions);
            var action = actions[max_max_match_i];
            console.log("Making action: ", action);
            var _loop_2 = function (attack_card_index) {
                tween.call(function () { return game_state.select_card(constants_2.SECOND_PLAYER, my_cards[attack_card_index].id, true); }).wait(1000);
            };
            for (var _i = 0, _a = action.attack_cards; _i < _a.length; _i++) {
                var attack_card_index = _a[_i];
                _loop_2(attack_card_index);
            }
            tween.call(function () {
                game_state.select_card(constants_2.FIRST_PLAYER, opponent_cards[action.target_card].id, true);
                _this.finish_play(game_state);
            });
        };
        return Computer;
    }());
    exports.Computer = Computer;
});
define("results", ["require", "exports", "main", "layout", "constants"], function (require, exports, main_2, layout_3, constants_3) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var results_screen = new layout_3.TiledLayout(layout_3.LayoutDirection.Vertical, 50);
    var GameResult;
    (function (GameResult) {
        GameResult[GameResult["None"] = 0] = "None";
        GameResult[GameResult["PlayerWins"] = 1] = "PlayerWins";
        GameResult[GameResult["AIWins"] = 2] = "AIWins";
        GameResult[GameResult["Tie"] = 3] = "Tie";
    })(GameResult = exports.GameResult || (exports.GameResult = {}));
    ;
    function get_game_result(game_state) {
        var player_hp = game_state.player_states[constants_3.FIRST_PLAYER].hp;
        var ai_hp = game_state.player_states[constants_3.SECOND_PLAYER].hp;
        if (player_hp <= 0 && ai_hp <= 0) {
            return GameResult.Tie;
        }
        else if (player_hp <= 0) {
            return GameResult.AIWins;
        }
        else if (ai_hp <= 0) {
            return GameResult.PlayerWins;
        }
        else {
            return GameResult.None;
        }
    }
    exports.get_game_result = get_game_result;
    function get_result_text(game_result) {
        if (game_result === GameResult.None) {
            console.error("GameResult.None is not the end of the game!");
        }
        else if (game_result === GameResult.PlayerWins) {
            return "Congrats! You win!";
        }
        else if (game_result === GameResult.AIWins) {
            return "Sorry, you lose. Try again!";
        }
        else {
            return "Tie!";
        }
    }
    function get_results_screen(game_state) {
        var outer_scale = 0.8;
        var game_result = get_game_result(game_state);
        results_screen.removeAllChildren();
        // let enemy_container = new TiledLayout(LayoutDirection.Horizontal, 0);
        // let enemy_container_graveyard = new TiledLayout(LayoutDirection.Horizontal, 0);
        // let enemy_cards = game_state.cards_inplay[SECOND_PLAYER].cards;
        // enemy_cards = enemy_cards.concat(game_state.cards_inhand[SECOND_PLAYER].cards);
        // const enemy_active_cards = enemy_cards.length;
        // enemy_cards = enemy_cards.concat(game_state.player_graveyard[SECOND_PLAYER]);
        // console.log(enemy_cards);
        // let index = 0;
        // let current_container = enemy_container;
        // for (let card of enemy_cards) {
        //     if (index === enemy_active_cards) {
        //         current_container = enemy_container_graveyard;
        //     }
        //     ++index;
        //     // createjs.Tween.removeTweens(card.container);
        //     card.container.x = 0;
        //     card.container.y = 0;
        //     current_container.addItem(card.container);
        //     card.set_visible(true);
        //     card.container.removeAllEventListeners();
        //     card.change_state(CardState.Destoyed);
        // }
        // enemy_container.scaleX = outer_scale;
        // enemy_container.scaleY = outer_scale;
        // enemy_container.y = 50;
        // enemy_container_graveyard.scaleX = outer_scale;
        // enemy_container_graveyard.scaleY = outer_scale;
        // enemy_container_graveyard.y = 50;
        // let player_container = new TiledLayout(LayoutDirection.Horizontal, 0);
        // let player_container_graveyard = new TiledLayout(LayoutDirection.Horizontal, 0);
        // let player_cards = game_state.cards_inplay[FIRST_PLAYER].cards;
        // player_cards = player_cards.concat(game_state.cards_inhand[FIRST_PLAYER].cards);
        // const player_active_cards = player_cards.length;
        // player_cards = player_cards.concat(game_state.player_graveyard[FIRST_PLAYER]);
        // index = 0;
        // current_container = player_container;
        // for (let card of player_cards) {
        //     if (index === player_active_cards) {
        //         current_container = player_container_graveyard;
        //     }
        //     ++index;
        //     // createjs.Tween.removeTweens(card.container);
        //     card.container.x = 0;
        //     card.container.y = 0;
        //     current_container.addItem(card.container);
        //     card.set_visible(true);
        //     card.container.removeAllEventListeners();
        //     card.change_state(CardState.Destoyed);
        // }
        // player_container.scaleX = outer_scale;
        // player_container.scaleY = outer_scale;
        // player_container.y = 50;
        // player_container_graveyard.scaleX = outer_scale;
        // player_container_graveyard.scaleY = outer_scale;
        // player_container_graveyard.y = 50;
        // let result_text = new createjs.Text(get_result_text(game_result), HP_TEXT_FONT, "red");
        var player_hp = game_state.player_states[constants_3.FIRST_PLAYER].hp;
        var ai_hp = game_state.player_states[constants_3.SECOND_PLAYER].hp;
        var result = new createjs.Sprite(main_2.assets.result_spritesheet);
        if (game_result === GameResult.PlayerWins) {
            result.gotoAndStop(0);
        }
        else if (game_result === GameResult.AIWins) {
            result.gotoAndStop(1);
        }
        else {
            result.gotoAndStop(2);
        }
        result.x = -result.getBounds().width / 2;
        var h = result.getBounds().height - 0;
        var you = new createjs.Text("YOU ", constants_3.HP_TEXT_FONT, "black");
        you.x = -70;
        you.y = h;
        var score = new createjs.Text(player_hp + " : " + ai_hp, constants_3.HP_TEXT_FONT, "red");
        score.x = you.x + you.getBounds().width;
        score.y = h;
        var ai = new createjs.Text(" AI", constants_3.HP_TEXT_FONT, "black");
        ai.x = score.x + score.getBounds().width;
        ai.y = h;
        var enemy_title = new createjs.Text("Enemy cards history:", constants_3.HP_TEXT_FONT);
        var player_title = new createjs.Text("Player cards history:", constants_3.HP_TEXT_FONT);
        var score_container = new createjs.Container();
        score_container.addChild(you);
        score_container.addChild(score);
        score_container.addChild(ai);
        score_container.addChild(result);
        score_container.x = (main_2.stage_width) / 2;
        score_container.y = 80;
        var bg = new createjs.Sprite(main_2.assets.results_bg_spritesheet);
        bg.scaleX = 0.7;
        bg.scaleY = 0.7;
        results_screen.addChild(bg);
        results_screen.addChild(score_container);
        return results_screen;
    }
    exports.get_results_screen = get_results_screen;
});
define("game_phase_indicator", ["require", "exports", "constants", "main"], function (require, exports, constants_4, main_3) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ELEMENT_SCALE = 0.7;
    var GAME_STATUS_TEXT_X_SHIFT = 140;
    function load_sprite(spritesheet, index, scale) {
        var sprite = new createjs.Sprite(spritesheet);
        sprite.gotoAndStop(index);
        sprite.setTransform(0, 0, scale, scale);
        // TODO: Remove this when we add preload.
        sprite.setBounds(0, 0, 400, 150);
        return sprite;
    }
    var GamePhaseIndicator = /** @class */ (function () {
        function GamePhaseIndicator() {
            this.container = new createjs.Container();
            this.container.regY = 100 * ELEMENT_SCALE;
            this.container.y = 17;
            var spritesheet = main_3.assets.phase_indicator_spritesheet;
            this.player_attack_container = new Array(2);
            this.player_attack_container[constants_4.FIRST_PLAYER] = new createjs.Container();
            this.player_attack_container[constants_4.SECOND_PLAYER] = new createjs.Container();
            this.player_attack_container[constants_4.FIRST_PLAYER].addChild(load_sprite(spritesheet, 1, ELEMENT_SCALE));
            this.player_attack_container[constants_4.SECOND_PLAYER].addChild(load_sprite(spritesheet, 2, ELEMENT_SCALE));
            this.tactics_container = new createjs.Container();
            this.tactics_container.addChild(load_sprite(spritesheet, 0, ELEMENT_SCALE));
            this.game_status_text = new createjs.Text("-----", constants_4.REGEX_STRING_TEXT_FONT, "white");
            this.game_status_text.textAlign = "center";
            this.game_status_text.textBaseline = "middle";
            this.game_status_text.x = GAME_STATUS_TEXT_X_SHIFT;
            this.game_status_text.y = this.container.regY;
            this.current_player = constants_4.FIRST_PLAYER;
            this.current_phase = constants_4.GamePhase.Changing;
            this.container.addChild(this.tactics_container);
            this.container.addChild(this.player_attack_container[constants_4.FIRST_PLAYER]);
            this.container.addChild(this.player_attack_container[constants_4.SECOND_PLAYER]);
            this.container.addChild(this.game_status_text);
            this.update_phase_status();
        }
        GamePhaseIndicator.prototype.set_text = function (text) {
            this.game_status_text.text = text;
        };
        GamePhaseIndicator.prototype.set_regex_text = function (regex_text) {
            if (regex_text.length == 0) {
                this.update_phase_status();
            }
            else {
                this.set_text(regex_text);
            }
        };
        GamePhaseIndicator.prototype.redraw_phase_status = function () {
            main_3.input_disable.i++;
            createjs.Tween.get(this.container)
                .to({ scaleY: 0 }, 300, createjs.Ease.getPowIn(4))
                .call(function () {
                this.update_phase_status();
            }, null, this)
                .to({ scaleY: 1 }, 300, createjs.Ease.getPowOut(4))
                .call(function () { main_3.input_disable.i--; });
        };
        GamePhaseIndicator.prototype.update_phase_status = function () {
            this.player_attack_container[constants_4.FIRST_PLAYER].visible = false;
            this.player_attack_container[constants_4.SECOND_PLAYER].visible = false;
            this.tactics_container.visible = false;
            if (this.current_phase == constants_4.GamePhase.Changing) {
                this.tactics_container.visible = true;
                if (this.current_player == constants_4.FIRST_PLAYER) {
                    this.set_text("YOU SWAP");
                }
                else {
                    this.set_text("ENEMY SWAPS");
                }
            }
            else if (this.current_phase == constants_4.GamePhase.Matching) {
                this.player_attack_container[this.current_player].visible = true;
                if (this.current_player == constants_4.FIRST_PLAYER) {
                    this.set_text("YOU ATTACK");
                }
                else {
                    this.set_text("ENEMY ATTACKS");
                }
            }
        };
        GamePhaseIndicator.prototype.set_player = function (current_player) {
            if (current_player === this.current_player)
                return;
            this.current_player = current_player;
            // if (this.current_phase === GamePhase.Changing) return;
            this.redraw_phase_status();
        };
        GamePhaseIndicator.prototype.set_phase = function (current_phase) {
            if (current_phase === this.current_phase)
                return;
            this.current_phase = current_phase;
            this.redraw_phase_status();
        };
        return GamePhaseIndicator;
    }());
    exports.GamePhaseIndicator = GamePhaseIndicator;
});
define("resource_loader", ["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function loadResources(callback, stage, assets) {
        var loadingText = new createjs.Text("Loading 0%", "30px Arial", "Black");
        loadingText.textAlign = "center";
        loadingText.textBaseline = "middle";
        loadingText.x = stage.canvas.width / 2;
        loadingText.y = stage.canvas.height / 2;
        stage.addChild(loadingText);
        stage.update();
        var queue = new createjs.LoadQueue(true);
        var handleComplete = function () {
            stage.removeChild(loadingText);
            assets.health_spritesheet = queue.getResult("health");
            assets.cards_spritesheet = queue.getResult("cards");
            assets.keys_spritesheet = queue.getResult("keys");
            assets.phase_indicator_spritesheet = queue.getResult("phase_indicator");
            assets.skip_button_spritesheet = queue.getResult("skip_button");
            assets.instructions_spritesheet = queue.getResult("instructions");
            assets.game_bg_spritesheet = queue.getResult("game_bg");
            assets.border_spritesheet = queue.getResult("border");
            assets.health_fill_bitmap = createjs.SpriteSheetUtils.extractFrame(assets.health_spritesheet, 0);
            assets.menu_button_spritesheet = queue.getResult("menu_button");
            assets.menu_bg_spritesheet = queue.getResult("menu_bg");
            assets.difficulty_button_spritesheet = queue.getResult("difficulty_button");
            assets.result_spritesheet = queue.getResult("result");
            assets.results_bg_spritesheet = queue.getResult("results_bg");
            callback();
        };
        var updateLoading = function () {
            loadingText.text = "Loading " + (queue.progress * 100 | 0) + "%";
            stage.update();
        };
        queue.on("complete", handleComplete, this);
        queue.on("progress", updateLoading);
        queue.loadFile({ src: "img/health_sprite.json", id: "health", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/cards_sprite.json", id: "cards", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/keys_sprite.json", id: "keys", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/phase_indicator_sprite.json", id: "phase_indicator", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/skip_button_sprite.json", id: "skip_button", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/instructions_sprite.json", id: "instructions", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/game_bg.json", id: "game_bg", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/border.json", id: "border", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/menu_button_sprite.json", id: "menu_button", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/menu_bg.json", id: "menu_bg", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/difficulty_button_sprite.json", id: "difficulty_button", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/result_sprite.json", id: "result", type: createjs.AbstractLoader.SPRITESHEET });
        queue.loadFile({ src: "img/results_bg.json", id: "results_bg", type: createjs.AbstractLoader.SPRITESHEET });
    }
    exports.loadResources = loadResources;
});
define("menu", ["require", "exports", "layout", "main"], function (require, exports, layout_4, main_4) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var menu_screen = new layout_4.TiledLayout(layout_4.LayoutDirection.Vertical, 50);
    function get_menu_screen() {
        menu_screen.removeAllChildren();
        var bg = new createjs.Sprite(main_4.assets.menu_bg_spritesheet);
        bg.scaleX = 0.7;
        bg.scaleY = 0.7;
        var start_button = new createjs.Sprite(main_4.assets.menu_button_spritesheet);
        start_button.x = (main_4.stage_width - start_button.getBounds().width) / 2;
        start_button.y = (main_4.stage_height - start_button.getBounds().height) / 2;
        start_button.addEventListener("click", function (event) {
            main_4.change_screen(main_4.game_screen);
        });
        menu_screen.addChild(bg);
        menu_screen.addChild(start_button);
        return menu_screen;
    }
    exports.get_menu_screen = get_menu_screen;
});
define("main", ["require", "exports", "card", "player", "utils", "layout", "constants", "computer", "results", "game_phase_indicator", "resource_loader", "menu"], function (require, exports, card_3, player_1, utils_3, layout_5, constants_5, computer_1, results_1, game_phase_indicator_1, resource_loader_1, menu_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var MAX_HEIGHT;
    var MAX_WIDTH;
    var desired_aspect;
    var mouse = {
        x: 0,
        y: 0
    };
    exports.stage_width = 0;
    exports.stage_height = 0;
    exports.input_disable = {
        i: 0
    };
    var GameState = /** @class */ (function () {
        function GameState(game_field) {
            var _this = this;
            this.cards_inplay = new Array(constants_5.PLAYER_COUNT);
            this.cards_inplay[constants_5.FIRST_PLAYER] = new player_1.InPlay(card_3.generate_cards(3));
            this.cards_inplay[constants_5.SECOND_PLAYER] = new player_1.InPlay(card_3.generate_cards(3));
            this.cards_inhand = new Array(constants_5.PLAYER_COUNT);
            this.cards_inhand[constants_5.FIRST_PLAYER] = new player_1.Hand(card_3.generate_cards(4));
            this.cards_inhand[constants_5.SECOND_PLAYER] = new player_1.Hand(card_3.generate_cards(4));
            this.player_states = player_1.generate_players();
            this.player_graveyard = new Array(constants_5.PLAYER_COUNT);
            this.player_graveyard[constants_5.FIRST_PLAYER] = new Array();
            this.player_graveyard[constants_5.SECOND_PLAYER] = new Array();
            this.selected_cards = [];
            this.id_to_card = {};
            this.computer_thinking = false;
            this.game_phase_indicator = new game_phase_indicator_1.GamePhaseIndicator();
            this.create_skip_turn_button();
            this.skip_turn_button.on("click", function (event) {
                if (_this.current_player === constants_5.SECOND_PLAYER) {
                    return;
                }
                _this.change_player();
            });
            this.set_player(constants_5.FIRST_PLAYER);
            this.computer = new computer_1.Computer();
            var _loop_3 = function (i) {
                // cards in play
                {
                    var cards = this_2.cards_inplay[i].cards;
                    var container = this_2.cards_inplay[i].container;
                    var _loop_4 = function (j) {
                        var id = cards[j].id;
                        cards[j].container.on("click", function (event) {
                            _this.select_card(i, id, false);
                        });
                        this_2.add_card(cards[j]);
                    };
                    for (var j = 0; j < cards.length; ++j) {
                        _loop_4(j);
                    }
                }
                // cards in hands
                {
                    var cards = this_2.cards_inhand[i].cards;
                    var container = this_2.cards_inhand[i].container;
                    var _loop_5 = function (j) {
                        var id = cards[j].id;
                        cards[j].container.on("click", function (event) {
                            _this.select_card(i, id, false);
                        });
                        this_2.add_card(cards[j]);
                        if (i === constants_5.SECOND_PLAYER) {
                            cards[j].set_visible(false);
                        }
                    };
                    for (var j = 0; j < cards.length; ++j) {
                        _loop_5(j);
                    }
                }
            };
            var this_2 = this;
            for (var i = 0; i < constants_5.PLAYER_COUNT; ++i) {
                _loop_3(i);
            }
            createjs.Ticker.on("tick", function (event) {
                this.update_regex_highlight();
                this.hover_cards();
            }, this);
            var verticalLayout = new layout_5.TiledLayout(layout_5.LayoutDirection.Vertical, 35, true, exports.stage_width);
            verticalLayout.addItem(this.cards_inhand[constants_5.SECOND_PLAYER].container);
            verticalLayout.addItem(this.cards_inplay[constants_5.SECOND_PLAYER].container, -30);
            verticalLayout.addItem(this.game_phase_indicator.container);
            verticalLayout.addItem(this.cards_inplay[constants_5.FIRST_PLAYER].container, -20);
            verticalLayout.addItem(this.cards_inhand[constants_5.FIRST_PLAYER].container, -15);
            verticalLayout.apply_centering();
            this.battlefield_container = new createjs.Container();
            this.battlefield_container.addChild(verticalLayout);
            this.battlefield_container.addChild(this.skip_turn_button);
            game_field.addChild(this.battlefield_container);
            this.create_hp_containers();
            this.create_instruction_bubble();
            this.computer.difficulty_container.x = exports.stage_width - 195;
            this.computer.difficulty_container.y = 220;
            this.battlefield_container.addChild(this.computer.difficulty_container);
            this.half_round_index = 0;
            this.set_phase(constants_5.GamePhase.Changing);
            this.update_instruction_bubble();
        }
        GameState.prototype.create_hp_containers = function () {
            this.player_hp_containers = new Array(2);
            this.player_hp_containers[constants_5.FIRST_PLAYER] = new createjs.Container();
            this.player_hp_containers[constants_5.SECOND_PLAYER] = new createjs.Container();
            this.player_hp_texts = new Array();
            this.player_hp_texts[constants_5.FIRST_PLAYER] = new createjs.Text(this.player_states[constants_5.FIRST_PLAYER].hp.toString(), constants_5.HP_TEXT_FONT);
            this.player_hp_texts[constants_5.SECOND_PLAYER] = new createjs.Text(this.player_states[constants_5.SECOND_PLAYER].hp.toString(), constants_5.HP_TEXT_FONT);
            this.player_brains = new Array();
            {
                this.player_brains[constants_5.FIRST_PLAYER] = new createjs.Bitmap(exports.assets.health_fill_bitmap);
                this.player_brains[constants_5.FIRST_PLAYER].scaleX = -1;
                this.player_brains[constants_5.FIRST_PLAYER].regX = +21;
                var player_brain_full = this.player_brains[constants_5.FIRST_PLAYER];
                player_brain_full.sourceRect = new createjs.Rectangle(0, 0, 21, 16);
                var player_brain_empty = new createjs.Sprite(exports.assets.health_spritesheet);
                player_brain_empty.gotoAndStop(1);
                player_brain_empty.scaleX = -1;
                player_brain_empty.regX = +21;
                this.player_hp_texts[constants_5.FIRST_PLAYER].x = 21 /*player_heart_full.getBounds().width*/ + 5;
                this.player_hp_texts[constants_5.FIRST_PLAYER].y = -3;
                this.player_hp_containers[constants_5.FIRST_PLAYER].x = 97;
                this.player_hp_containers[constants_5.FIRST_PLAYER].y = 682;
                this.player_hp_containers[constants_5.FIRST_PLAYER].addChild(player_brain_empty, player_brain_full, this.player_hp_texts[constants_5.FIRST_PLAYER]);
                this.battlefield_container.addChild(this.player_hp_containers[constants_5.FIRST_PLAYER]);
            }
            {
                this.player_brains[constants_5.SECOND_PLAYER] = new createjs.Bitmap(exports.assets.health_fill_bitmap);
                var enemy_hp_text = this.player_hp_texts[constants_5.SECOND_PLAYER];
                enemy_hp_text.x = 0;
                enemy_hp_text.y = -3;
                var enemy_brain_full = this.player_brains[constants_5.SECOND_PLAYER];
                enemy_brain_full.x = 5 + enemy_hp_text.getBounds().width;
                enemy_brain_full.y = 0;
                enemy_brain_full.sourceRect = new createjs.Rectangle(0, 0, 21, 16);
                var enemy_brain_empty = new createjs.Sprite(exports.assets.health_spritesheet);
                enemy_brain_empty.x = enemy_brain_full.x;
                enemy_brain_empty.y = enemy_brain_full.y;
                enemy_brain_empty.gotoAndStop(1);
                this.player_hp_containers[constants_5.SECOND_PLAYER].x = exports.stage_width - 154;
                this.player_hp_containers[constants_5.SECOND_PLAYER].y = 363;
                this.player_hp_containers[constants_5.SECOND_PLAYER].addChild(enemy_brain_empty, enemy_brain_full, this.player_hp_texts[constants_5.SECOND_PLAYER]);
                this.battlefield_container.addChild(this.player_hp_containers[constants_5.SECOND_PLAYER]);
            }
        };
        GameState.prototype.update_brains = function () {
            {
                var player_hp = this.player_states[constants_5.FIRST_PLAYER].hp;
                var v = (player_hp * 1.0) / constants_5.START_HP;
                var height = Math.max(0, 16 * v);
                this.player_brains[constants_5.FIRST_PLAYER].sourceRect = new createjs.Rectangle(0, 16 - height, 21, height);
                this.player_brains[constants_5.FIRST_PLAYER].y = 16 - height;
                this.player_hp_texts[constants_5.FIRST_PLAYER].text = player_hp.toString();
            }
            {
                var enemy_hp = this.player_states[constants_5.SECOND_PLAYER].hp;
                var v = (enemy_hp * 1.0) / constants_5.START_HP;
                var height = Math.max(0, 16 * v);
                this.player_brains[constants_5.SECOND_PLAYER].sourceRect = new createjs.Rectangle(0, 16 - height, 21, height);
                this.player_brains[constants_5.SECOND_PLAYER].y = 16 - height;
                this.player_hp_texts[constants_5.SECOND_PLAYER].text = enemy_hp.toString();
            }
        };
        GameState.prototype.create_instruction_bubble = function () {
            this.player_instructions = new createjs.Sprite(exports.assets.instructions_spritesheet);
            this.player_instructions.x = 32;
            this.player_instructions.y = 527;
            this.player_instructions.scaleX = 0.6;
            this.player_instructions.scaleY = 0.6;
            this.battlefield_container.addChild(this.player_instructions);
        };
        GameState.prototype.update_instruction_bubble = function () {
            if (this.current_player === constants_5.FIRST_PLAYER) {
                if (this.phase === constants_5.GamePhase.Changing) {
                    this.player_instructions.gotoAndStop(1);
                }
                else {
                    this.player_instructions.gotoAndStop(0);
                }
            }
            else {
                this.player_instructions.gotoAndStop(2);
            }
        };
        GameState.prototype.create_skip_turn_button = function () {
            this.skip_turn_button = new createjs.Sprite(exports.assets.skip_button_spritesheet);
            this.skip_turn_button.x = 75;
            this.skip_turn_button.y = 448;
        };
        GameState.prototype.update_skip_turn_button = function () {
            if (this.current_player === constants_5.FIRST_PLAYER) {
                this.skip_turn_button.gotoAndStop(0);
            }
            else {
                this.skip_turn_button.gotoAndStop(1);
            }
        };
        GameState.prototype.highlight_for_card = function (owner, card) {
            var regex_prefix = "";
            if (this.phase === constants_5.GamePhase.Matching) {
                if (this.current_player !== constants_5.FIRST_PLAYER || owner !== constants_5.FIRST_PLAYER)
                    return;
                if (this.selected_cards.indexOf(card) >= 0)
                    return;
                regex_prefix = this.get_regex_string();
            }
            var local = card.container.globalToLocal(mouse.x, mouse.y);
            var bounds = card.container.getBounds();
            if (local.x >= bounds.x && local.y >= bounds.y &&
                local.x <= bounds.x + bounds.width && local.y <= bounds.y + bounds.height) {
                for (var _i = 0, _a = this.cards_inplay[1 - owner].cards; _i < _a.length; _i++) {
                    var enemy_card = _a[_i];
                    enemy_card.show_highlight(regex_prefix + card.regex);
                }
            }
        };
        GameState.prototype.update_regex_highlight = function () {
            for (var i = 0; i < constants_5.PLAYER_COUNT; ++i) {
                for (var _i = 0, _a = this.cards_inplay[i].cards; _i < _a.length; _i++) {
                    var card = _a[_i];
                    card.pre_update_highlight();
                }
                for (var _b = 0, _c = this.cards_inhand[i].cards; _b < _c.length; _b++) {
                    var card = _c[_b];
                    card.pre_update_highlight();
                }
            }
            for (var i = 0; i < constants_5.PLAYER_COUNT; ++i) {
                for (var _d = 0, _e = this.cards_inplay[i].cards; _d < _e.length; _d++) {
                    var card = _e[_d];
                    this.highlight_for_card(i, card);
                }
                if (i == constants_5.FIRST_PLAYER)
                    for (var _f = 0, _g = this.cards_inhand[i].cards; _f < _g.length; _f++) {
                        var card = _g[_f];
                        this.highlight_for_card(i, card);
                    }
            }
            if (this.phase === constants_5.GamePhase.Matching) {
                var attack_regex = this.get_regex_string();
                for (var _h = 0, _j = this.cards_inplay[1 - this.current_player].cards; _h < _j.length; _h++) {
                    var card = _j[_h];
                    card.show_attack_highlight(attack_regex);
                }
            }
            for (var i = 0; i < constants_5.PLAYER_COUNT; ++i) {
                for (var _k = 0, _l = this.cards_inplay[i].cards; _k < _l.length; _k++) {
                    var card = _l[_k];
                    card.update_highlight();
                }
                for (var _m = 0, _o = this.cards_inhand[i].cards; _m < _o.length; _m++) {
                    var card = _o[_m];
                    card.update_highlight();
                }
            }
        };
        GameState.prototype.hover_cards = function () {
            if (exports.input_disable.i)
                return;
            for (var i = 0; i < constants_5.PLAYER_COUNT; ++i) {
                for (var _i = 0, _a = this.cards_inplay[i].cards; _i < _a.length; _i++) {
                    var card = _a[_i];
                    var could_be_increased = this.phase === constants_5.GamePhase.Matching
                        || (this.phase === constants_5.GamePhase.Changing && i == constants_5.FIRST_PLAYER
                            && this.cards_inhand[constants_5.FIRST_PLAYER].get_selected_for_swap() !== null);
                    if (this.phase === constants_5.GamePhase.Matching && i === constants_5.FIRST_PLAYER &&
                        this.selected_cards.indexOf(card) < 0 && !utils_3.is_regex_valid(this.get_regex_string() + card.regex)) {
                        could_be_increased = false;
                    }
                    if (this.phase === constants_5.GamePhase.Matching && i === constants_5.SECOND_PLAYER && this.get_regex_string().length === 0) {
                        could_be_increased = false;
                    }
                    card.update_hover(mouse, could_be_increased);
                }
            }
            for (var _b = 0, _c = this.cards_inhand[constants_5.FIRST_PLAYER].cards; _b < _c.length; _b++) {
                var card = _c[_b];
                card.update_hover(mouse, this.current_player === constants_5.FIRST_PLAYER && this.phase === constants_5.GamePhase.Changing);
            }
        };
        GameState.prototype.set_phase = function (phase) {
            this.phase = phase;
            this.game_phase_indicator.set_phase(phase);
        };
        GameState.prototype.set_player = function (player) {
            this.current_player = player;
            this.game_phase_indicator.set_player(player);
            this.update_skip_turn_button();
        };
        GameState.prototype.add_card = function (card) {
            this.id_to_card[card.id] = card;
        };
        GameState.prototype.get_card = function (card_id) {
            if (this.id_to_card[card_id] === undefined) {
                console.error("Can't find card " + card_id);
            }
            return this.id_to_card[card_id];
        };
        GameState.prototype.select_card = function (owner, card_id, is_computer) {
            console.log("Selecting card (" + owner + ", " + card_id + ")");
            if ((this.computer_thinking || exports.input_disable.i) && !is_computer) {
                return;
            }
            if (this.phase === constants_5.GamePhase.Changing) {
                this.select_card_while_changing(owner, card_id, is_computer);
            }
            else if (this.phase == constants_5.GamePhase.Matching) {
                this.select_card_while_matching(owner, card_id, is_computer);
            }
        };
        GameState.prototype.select_card_while_changing = function (owner, card_id, is_computer) {
            var players_hand = this.cards_inhand[this.current_player];
            var players_play = this.cards_inplay[this.current_player];
            var card_selected_for_swap_in_hand = players_hand.get_selected_for_swap();
            var card = this.get_card(card_id);
            if (owner !== this.current_player) {
                if (card_selected_for_swap_in_hand !== null) {
                    console.log("You can not swap your card with your opponent's card");
                    // you can not change other player's cards
                }
                else {
                    console.log("Skip changing phase");
                    // just skipping turn
                    this.change_player();
                }
                return;
            }
            if (card.state === card_3.CardState.InPlay) {
                if (card_selected_for_swap_in_hand) {
                    console.log("Swapping cards");
                    // swapping cards
                    this.swap_cards(owner, card_selected_for_swap_in_hand, card);
                }
            }
            else if (card.state === card_3.CardState.InHand) {
                console.log("Select for swap");
                if (card.selected_for_swap) {
                    card.select_for_swap(false);
                }
                else {
                    for (var k = 0; k < players_hand.cards.length; ++k) {
                        players_hand.cards[k].select_for_swap(false);
                    }
                    card.select_for_swap(true);
                }
            }
        };
        GameState.prototype.swap_cards = function (owner, card_in_hand, card_in_play) {
            exports.input_disable.i++;
            card_in_hand.select_for_swap(false);
            card_in_play.select_for_swap(false);
            var hand_pos = { x: card_in_hand.container.x, y: card_in_hand.container.y };
            var play_pos = { x: card_in_play.container.x, y: card_in_play.container.y };
            var glob_hand_pos = card_in_hand.container.localToGlobal(card_in_hand.container.getBounds().width / 2, card_in_hand.container.getBounds().height / 2);
            var glob_play_pos = card_in_play.container.localToGlobal(card_in_play.container.getBounds().width / 2, card_in_play.container.getBounds().height / 2);
            var ai_move = (owner == constants_5.SECOND_PLAYER);
            var in_out = createjs.Ease.getPowInOut(2);
            createjs.Tween.get(card_in_play.container)
                .to({
                scaleX: card_3.CARD_SCALE + card_3.SWAP_HOVER,
                scaleY: card_3.CARD_SCALE + card_3.SWAP_HOVER,
                rotation: 90,
                x: card_in_play.container.x - 800
            }, 500, in_out);
            createjs.Tween.get(card_in_hand.container)
                .to({
                scaleX: card_3.CARD_SCALE + card_3.SWAP_HOVER,
                scaleY: card_3.CARD_SCALE + card_3.SWAP_HOVER
            }, 500, in_out)
                .call(function () {
                if (ai_move)
                    this.set_visible(true, true, false);
            }, null, card_in_hand)
                .to({
                x: card_in_hand.container.x + glob_play_pos.x - glob_hand_pos.x,
                y: card_in_hand.container.y + glob_play_pos.y - glob_hand_pos.y
            }, 600, in_out)
                .to({
                scaleX: card_3.CARD_SCALE,
                scaleY: card_3.CARD_SCALE
            }, 300, in_out)
                .call(function () {
                var players_hand = this.cards_inhand[owner];
                var players_play = this.cards_inplay[owner];
                //console.log("Before");
                //console.log("Card in hand: " + card_in_hand.id);
                //console.log("Card in play: " + card_in_play.id);
                var hand_card_index = players_hand.cards.indexOf(card_in_hand);
                var play_card_index = players_play.cards.indexOf(card_in_play);
                _a = [
                    players_play.cards[play_card_index],
                    players_hand.cards[hand_card_index]
                ], players_hand.cards[hand_card_index] = _a[0], players_play.cards[play_card_index] = _a[1];
                hand_card_index = players_hand.container.getChildIndex(card_in_hand.container);
                play_card_index = players_play.container.getChildIndex(card_in_play.container);
                players_hand.container.removeChild(card_in_hand.container);
                players_hand.container.addChildAt(card_in_play.container, hand_card_index);
                players_play.container.removeChild(card_in_play.container);
                players_play.container.addChildAt(card_in_hand.container, play_card_index);
                _b = [
                    play_pos.x,
                    play_pos.y,
                    hand_pos.x,
                    hand_pos.y
                ], card_in_hand.container.x = _b[0], card_in_hand.container.y = _b[1], card_in_play.container.x = _b[2], card_in_play.container.y = _b[3];
                card_in_hand.change_state(card_3.CardState.InPlay);
                card_in_hand.hover = 0;
                //console.log("Before");
                //console.log("Card in hand: " + card_in_hand.id);
                //console.log("Card in play: " + card_in_play.id);
                this.discard_and_pick_new(owner, card_in_play);
                this.change_player();
                exports.input_disable.i--;
                var _a, _b;
            }, null, this);
        };
        GameState.prototype.discard_and_pick_new = function (owner, card_in_hand) {
            var _this = this;
            this.player_graveyard[owner].push(card_in_hand);
            var new_card = this.player_states[owner].pick_card_from_deck();
            if (new_card === null) {
                console.error("No card in deck!. Pls implement something here!");
            }
            else {
                this.cards_inhand[owner].change_card(card_in_hand, new_card);
                var id_1 = new_card.id;
                new_card.container.on("click", function (event) {
                    _this.select_card(owner, id_1, false);
                });
                this.add_card(new_card);
                new_card.set_visible(false);
                exports.input_disable.i++;
                var ai_1 = (owner == constants_5.SECOND_PLAYER);
                var target_pos = { x: new_card.container.x, y: new_card.container.y };
                new_card.container.x = exports.stage_width + 200;
                new_card.container.y += ai_1 ? 200 : -200;
                new_card.container.rotation = 90;
                new_card.container.scaleX = new_card.container.scaleY = card_3.CARD_SCALE + card_3.SWAP_HOVER;
                var in_out = createjs.Ease.getPowInOut(2);
                var tween = createjs.Tween.get(new_card.container)
                    .to({
                    x: target_pos.x,
                    y: target_pos.y,
                    rotation: 0
                }, 800, in_out);
                if (ai_1)
                    tween.to({
                        scaleX: card_3.CARD_SCALE, scaleY: card_3.CARD_SCALE
                    }, 300, in_out);
                tween.call(function () {
                    if (!ai_1) {
                        new_card.set_visible(true, true);
                    }
                    exports.input_disable.i--;
                }, null, this);
            }
        };
        GameState.prototype.select_card_while_matching = function (owner, card_id, is_computer) {
            var card = this.get_card(card_id);
            if (owner === this.current_player) {
                if (card.state === card_3.CardState.InPlay) {
                    if (!card.selected) {
                        var new_regex_string = this.get_regex_string() + card.regex;
                        if (utils_3.is_regex_valid(new_regex_string)) {
                            this.selected_cards.push(card);
                            card.select(this.selected_cards.length);
                            this.game_phase_indicator.set_regex_text(new_regex_string);
                        }
                    }
                    else {
                        var index = this.selected_cards.indexOf(card);
                        if (index + 1 === this.selected_cards.length) {
                            this.selected_cards.splice(index);
                            card.deselect();
                            this.game_phase_indicator.set_regex_text(this.get_regex_string());
                        }
                    }
                }
            }
            else {
                if (card.state === card_3.CardState.InPlay) {
                    if (this.get_regex_string().length > 0 || this.current_player == constants_5.SECOND_PLAYER) {
                        this.attack(card);
                        this.change_player();
                    }
                }
            }
        };
        GameState.prototype.change_player = function () {
            if (results_1.get_game_result(this) !== results_1.GameResult.None) {
                exports.change_screen(results_1.get_results_screen(this));
                return;
            }
            this.half_round_index += 1;
            if (this.half_round_index % 2 === 0) {
                console.log("Changing phase", this.half_round_index);
                this.change_phase();
            }
            this.set_player(utils_3.oppositePlayer(this.current_player));
            if (this.half_round_index % 4 === 0) {
                console.log("Changing player", this.half_round_index);
                this.set_player(utils_3.oppositePlayer(this.current_player));
            }
            if (this.current_player == constants_5.SECOND_PLAYER) {
                this.computer.play_as_computer(this);
            }
            this.update_instruction_bubble();
        };
        GameState.prototype.change_phase = function () {
            if (this.phase === constants_5.GamePhase.Changing) {
                console.log("Matching phase started");
                this.set_phase(constants_5.GamePhase.Matching);
            }
            else if (this.phase === constants_5.GamePhase.Matching) {
                console.log("Changing phase started");
                this.set_phase(constants_5.GamePhase.Changing);
            }
        };
        GameState.prototype.get_regex_string = function () {
            var regex_string = "";
            for (var i = 0; i < this.selected_cards.length; ++i) {
                regex_string += this.selected_cards[i].regex;
            }
            return regex_string;
        };
        GameState.prototype.attack = function (card) {
            var regex_string = this.get_regex_string();
            console.log("Attacking \"" + card.password + "\" with \"" + regex_string + "\"");
            var max_match = utils_3.get_max_match(regex_string, card.password);
            console.log("Max match: \"" + max_match + "\"");
            var damage = max_match.length;
            this.player_states[utils_3.oppositePlayer(this.current_player)].deal_damage(damage);
            // card.remove_password(regex_string);
            // updating brain bar
            this.update_brains();
            for (var i = 0; i < this.selected_cards.length; ++i) {
                this.selected_cards[i].deselect();
            }
            this.selected_cards = [];
            card.show_attacked(damage);
            this.game_phase_indicator.set_regex_text("");
        };
        return GameState;
    }());
    exports.GameState = GameState;
    ;
    function create_background() {
        // TODO: Move this out.
        var game_field_bg = new createjs.Sprite(exports.assets.game_bg_spritesheet);
        game_field_bg.setTransform(0, 0, 0.7, 0.7);
        game_field_bg.gotoAndStop(0);
        var border = new createjs.Sprite(exports.assets.border_spritesheet);
        border.setTransform(0, 0, 0.7, 0.7);
        border.gotoAndStop(0);
        return [game_field_bg, border];
    }
    function init() {
        var stage = new createjs.Stage('RegExkcdStage');
        var canvas = stage.canvas;
        MAX_HEIGHT = canvas.width;
        MAX_WIDTH = canvas.height;
        desired_aspect = MAX_WIDTH / MAX_HEIGHT;
        // resize(stage);
        stage.mouseEnabled = true;
        exports.stage_width = canvas.width;
        exports.stage_height = canvas.height;
        exports.assets = {};
        resource_loader_1.loadResources(function () { play(stage); }, stage, exports.assets);
    }
    exports.init = init;
    function resize(stage) {
        exports.stage_width = Math.min(window.innerWidth, MAX_WIDTH);
        exports.stage_height = Math.min(window.innerHeight, MAX_HEIGHT);
        console.log("Stage: " + stage.canvas.width + ":" + stage.canvas.height);
        console.log("Resize to: " + exports.stage_width + ":" + exports.stage_height);
        var scale_w = exports.stage_width / stage.canvas.width;
        var scale_h = exports.stage_height / stage.canvas.height;
        var scale = Math.min(scale_w, scale_h);
        stage.scaleX = scale;
        stage.scaleY = scale;
        stage.canvas.width *= scale;
        stage.canvas.height *= scale;
        exports.stage_width = stage.canvas.width;
        exports.stage_height = stage.canvas.height;
        console.log("Resize to: " + stage.canvas.width + ":" + stage.canvas.height);
    }
    function play(stage) {
        console.log(exports.assets);
        var god_screen = new createjs.Container();
        exports.change_screen = function (screen) {
            god_screen.removeAllChildren();
            god_screen.addChild(screen);
        };
        stage.addChild(god_screen);
        // TODO: Refactor this.
        var v = create_background();
        stage.addChild(v[1]);
        exports.game_screen = new createjs.Container();
        // Init game screen
        {
            var game_field = new createjs.Container();
            var game = new GameState(game_field);
            game_field.setTransform(0, constants_5.GAME_FIELD_Y);
            exports.game_screen.addChild(v[0]);
            exports.game_screen.addChild(game_field);
        }
        exports.change_screen(menu_1.get_menu_screen());
        stage.on("stagemousemove", function (event) {
            mouse.x = event.stageX;
            mouse.y = event.stageY;
        });
        createjs.Ticker.framerate = 60;
        createjs.Ticker.addEventListener("tick", stage);
    }
    exports.play = play;
});
define("card", ["require", "exports", "constants", "utils", "decks", "main"], function (require, exports, constants_6, utils_4, decks_1, main_5) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var IMAGE_COUNT = 30;
    function card_from_spec(card_spec) {
        return new Card(card_spec.regex, card_spec.password, card_spec.image_index, card_spec.original_key_class);
    }
    exports.card_from_spec = card_from_spec;
    function generate_cards(card_count) {
        var cards = new Array(card_count);
        for (var i = 0; i < card_count; ++i) {
            cards[i] = card_from_spec(decks_1.draw_random_card_spec(decks_1.XKCD_MEME_CARDS));
        }
        return cards;
    }
    exports.generate_cards = generate_cards;
    var CardState;
    (function (CardState) {
        CardState[CardState["InPlay"] = 0] = "InPlay";
        CardState[CardState["InHand"] = 1] = "InHand";
        CardState[CardState["Destoyed"] = 2] = "Destoyed";
    })(CardState = exports.CardState || (exports.CardState = {}));
    ;
    exports.CARD_SCALE = 0.7;
    exports.SWAP_HOVER = 0.15;
    var HIGHLIGHT_MAX = 10;
    var Card = /** @class */ (function () {
        function Card(regex, password, image_index, card_class) {
            this.hover = 0;
            this.animating = false;
            this.highlighting_this_frame = false;
            this.highlighting_attack_this_frame = false;
            this.highlighting = false;
            this.highlight = 0;
            this.highlighted_regex = "";
            this.highlighting_attack = false;
            this.highlight_attack = 0;
            this.highlighted_attack_regex = "";
            if (!Card.card_sheets_initted) {
                Card.card_sheets_initted = true;
            }
            this.card_class = card_class;
            this.regex = regex;
            this.password = password;
            this.id = ++Card.card_count;
            this.selected = false;
            this.container_shown = new createjs.Container();
            this.container_hidden = new createjs.Container();
            this.password_text = new createjs.Text(this.password, constants_6.CARD_PASSWORD_TEXT_FONT);
            this.password_text.x = 50;
            this.password_text.y = 225;
            this.password_highlight = new createjs.Shape();
            this.password_highlight.visible = false;
            this.password_highlight.x = this.password_text.x;
            this.password_highlight.y = this.password_text.y;
            this.password_attack_highlight = new createjs.Shape();
            this.password_attack_highlight.visible = false;
            this.password_attack_highlight.x = this.password_text.x;
            this.password_attack_highlight.y = this.password_text.y;
            this.regex_text = new createjs.Text(this.regex, constants_6.CARD_REGEX_TEXT_FONT);
            this.regex_text.x = 50;
            this.regex_text.y = 260;
            this.regex_key_sprite = new createjs.Sprite(main_5.assets.keys_spritesheet);
            this.regex_key_sprite.gotoAndStop(card_class);
            this.regex_key_sprite.x = this.regex_text.x - 30;
            this.regex_key_sprite.y = this.regex_text.y - 3;
            var card_width = 200;
            var card_height = 300;
            this.in_play_card_envelope = new createjs.Container();
            {
                this.in_play_card_bg = new createjs.Sprite(main_5.assets.cards_spritesheet);
                this.in_play_card_bg.gotoAndStop(1);
                this.in_play_card_envelope.addChild(this.in_play_card_bg);
                var face = new createjs.Sprite(main_5.assets.cards_spritesheet);
                face.gotoAndStop(5 + image_index);
                this.in_play_card_envelope.addChild(face);
                this.in_play_attacked = new createjs.Sprite(main_5.assets.cards_spritesheet);
                this.in_play_attacked.gotoAndStop(4);
                this.in_play_attacked.visible = false;
                this.in_play_card_envelope.addChild(this.in_play_attacked);
                this.in_play_selected = new createjs.Sprite(main_5.assets.cards_spritesheet);
                this.in_play_selected.gotoAndStop(3);
                this.in_play_selected.visible = false;
                this.in_play_card_envelope.addChild(this.in_play_selected);
            }
            this.in_hand_card_envelope = new createjs.Sprite(main_5.assets.cards_spritesheet);
            this.in_hand_card_envelope.gotoAndStop(0);
            this.card_selection_number = new createjs.Text("", constants_6.CARD_SELECTION_TEXT_FONT, "white");
            this.card_selection_number.x = 153;
            this.card_selection_number.y = 175;
            this.container_shown.addChild(this.in_play_card_envelope);
            this.container_shown.addChild(this.card_selection_number);
            this.container_shown.addChild(this.regex_key_sprite);
            this.container_shown.addChild(this.regex_text);
            this.container_shown.addChild(this.password_attack_highlight);
            this.container_shown.addChild(this.password_highlight);
            this.container_shown.addChild(this.password_text);
            this.container_hidden.addChild(this.in_hand_card_envelope);
            this.container = new createjs.Container();
            this.container.regX = card_width / 2;
            this.container.regY = card_height / 2;
            this.container.x = card_width / 2 * exports.CARD_SCALE;
            this.container.y = card_height / 2 * exports.CARD_SCALE;
            this.container.setBounds(0, 0, card_width, card_height);
            this.container.scaleX = this.container.scaleY = exports.CARD_SCALE;
            this.change_state(CardState.InPlay);
            this.set_visible(true);
        }
        Card.prototype.select = function (index) {
            this.selected = true;
            this.card_selection_number.text = index.toString();
            this.in_play_selected.visible = true;
            this.select_for_swap(true);
        };
        Card.prototype.deselect = function () {
            this.selected = false;
            this.card_selection_number.text = "";
            this.in_play_selected.visible = false;
            this.select_for_swap(false);
        };
        Card.prototype.destroy = function () {
            console.log("Card destroyed");
            this.change_state(CardState.Destoyed);
            this.container.alpha = 0.5;
        };
        Card.prototype.pre_update_highlight = function () {
            this.highlighting_this_frame = false;
            this.highlighting_attack_this_frame = false;
        };
        Card.prototype.get_regex_match_box = function (regex) {
            var result = {};
            result.show = false;
            if (utils_4.is_regex_valid(regex)) {
                var max_match = utils_4.get_max_match(regex, this.password);
                if (max_match.length > 0) {
                    for (var i = 0; i <= this.password.length - max_match.length; i++) {
                        if (this.password.substr(i, max_match.length) == max_match) {
                            var pt = this.password_text;
                            result.x = pt._getMeasuredWidth(this.password.substr(0, i)) - 1;
                            result.width = pt._getMeasuredWidth(max_match) + 2;
                            break;
                        }
                    }
                    result.height = this.password_text.getMeasuredHeight() + 5;
                    result.show = true;
                }
            }
            return result;
        };
        Card.prototype.show_highlight = function (regex) {
            if (this.highlighting && this.highlighted_regex == regex) {
                this.highlighting_this_frame = true;
                return;
            }
            var result = this.get_regex_match_box(regex);
            if (result.show) {
                this.password_highlight.graphics.clear();
                this.password_highlight.graphics.beginFill("red").drawRoundRect(result.x, 0, result.width, result.height, 2);
                //this.password_highlight.graphics.endFill().beginStroke("red").moveTo(result.x, result.height).lineTo(result.x + result.width, result.height);
                this.password_highlight.alpha = 0;
                this.highlight = 0;
                this.highlighted_regex = regex;
                this.highlighting_this_frame = true;
            }
        };
        Card.prototype.show_attack_highlight = function (regex) {
            if (this.highlighting_attack && this.highlighted_attack_regex == regex) {
                this.highlighting_attack_this_frame = true;
                return;
            }
            var result = this.get_regex_match_box(regex);
            if (result.show) {
                this.password_attack_highlight.graphics.clear();
                this.password_attack_highlight.graphics.beginStroke("red").setStrokeStyle(3).drawRoundRect(result.x, 0, result.width, result.height, 2);
                this.password_attack_highlight.alpha = 0;
                this.highlight_attack = 0;
                this.highlighted_attack_regex = regex;
                this.highlighting_attack_this_frame = true;
            }
        };
        Card.prototype.update_highlight = function () {
            this.highlighting = this.highlighting_this_frame;
            if (this.highlighting) {
                this.highlight++;
            }
            else {
                this.highlight--;
            }
            if (this.highlight > HIGHLIGHT_MAX)
                this.highlight = HIGHLIGHT_MAX;
            if (this.highlight < 0)
                this.highlight = 0;
            this.password_highlight.visible = this.highlight > 0;
            this.password_highlight.alpha = 2 * 0.15 * this.highlight / HIGHLIGHT_MAX;
            this.highlighting_attack = this.highlighting_attack_this_frame;
            if (this.highlighting_attack) {
                this.highlight_attack++;
            }
            else {
                this.highlight_attack--;
            }
            if (this.highlight_attack > HIGHLIGHT_MAX)
                this.highlight_attack = HIGHLIGHT_MAX;
            if (this.highlight_attack < 0)
                this.highlight_attack = 0;
            this.password_attack_highlight.visible = this.highlight_attack > 0;
            this.password_attack_highlight.alpha = 0.6 * this.highlight_attack / HIGHLIGHT_MAX;
        };
        Card.prototype.remove_password = function (regex) {
            this.password = this.password.replace(regex, '');
            console.log("New password: " + this.password);
            this.password_text.text = this.password;
            if (this.password == "") {
                this.destroy();
            }
        };
        Card.prototype.change_state = function (state) {
            this.state = state;
        };
        Card.prototype.set_visible = function (visible, animate, put_down) {
            if (animate === void 0) { animate = false; }
            if (put_down === void 0) { put_down = true; }
            if (this.visible !== visible) {
                this.visible = visible;
                if (!animate) {
                    this.container.removeAllChildren();
                    if (visible) {
                        this.container.addChild(this.container_shown);
                    }
                    else {
                        this.container.addChild(this.container_hidden);
                    }
                }
                else {
                    this.animating = true;
                    var inOut = createjs.Ease.getPowInOut(2);
                    var tween = createjs.Tween.get(this.container)
                        .to({ scaleX: 0 }, 300, createjs.Ease.getPowIn(2))
                        .call(function () {
                        this.container.removeAllChildren();
                        this.container.addChild(visible ? this.container_shown : this.container_hidden);
                    }, null, this)
                        .to({ scaleX: exports.CARD_SCALE + exports.SWAP_HOVER }, 300, createjs.Ease.getPowOut(2));
                    if (put_down)
                        tween.to({ scaleX: exports.CARD_SCALE, scaleY: exports.CARD_SCALE }, 500, inOut);
                    tween.call(function () {
                        this.animating = false;
                    }, null, this);
                }
            }
        };
        Card.prototype.select_for_swap = function (selected_for_swap) {
            if (this.selected_for_swap !== selected_for_swap) {
                this.selected_for_swap = selected_for_swap;
                if (selected_for_swap) {
                    this.in_play_card_bg.gotoAndStop(2);
                }
                else {
                    this.in_play_card_bg.gotoAndStop(1);
                }
            }
        };
        Card.prototype.update_hover = function (mouse, could_be_increased) {
            if (this.animating)
                return;
            var local = this.container.globalToLocal(mouse.x, mouse.y);
            var bounds = this.container.getBounds();
            if (local.x >= bounds.x && local.y >= bounds.y &&
                local.x <= bounds.x + bounds.width && local.y <= bounds.y + bounds.height) {
                if (could_be_increased && this.state !== CardState.Destoyed) {
                    this.hover += 1;
                }
            }
            else {
                this.hover -= 1;
            }
            if (this.hover > 14)
                this.hover = 14;
            if (this.hover < 0)
                this.hover = 0;
            this.container.scaleX = this.container.scaleY = exports.CARD_SCALE + this.hover * 0.01;
        };
        Card.prototype.show_attacked = function (dmg) {
            this.animating = true;
            this.hover = 0;
            this.in_play_attacked.visible = true;
            this.in_play_attacked.alpha = 0;
            var dmg_text = new createjs.Text("-" + dmg.toString(), constants_6.CARD_DAMAGE_TEXT_FONT, "white");
            dmg_text.x = 145;
            dmg_text.y = 170;
            dmg_text.alpha = 0;
            this.container.addChild(dmg_text);
            var in_out = createjs.Ease.getPowInOut(2);
            var out = createjs.Ease.getPowOut(2);
            createjs.Tween.get(this.container)
                .to({ scaleX: exports.CARD_SCALE + exports.SWAP_HOVER, scaleY: exports.CARD_SCALE + exports.SWAP_HOVER }, 100, in_out)
                .wait(700)
                .to({ scaleX: exports.CARD_SCALE, scaleY: exports.CARD_SCALE }, 100, in_out);
            createjs.Tween.get(this.container)
                .to({ rotation: 5 }, 30)
                .to({ rotation: -5 }, 60)
                .to({ rotation: 5 }, 60)
                .to({ rotation: -5 }, 60)
                .to({ rotation: 5 }, 60)
                .to({ rotation: -5 }, 60)
                .to({ rotation: 0 }, 30);
            createjs.Tween.get(dmg_text)
                .to({ alpha: 1 }, 300, out)
                .wait(500)
                .to({ alpha: 0 }, 300);
            createjs.Tween.get(this.in_play_attacked)
                .to({ alpha: 1 }, 500, out)
                .wait(300)
                .to({ alpha: 0, visible: false }, 300)
                .call(function () {
                this.container.removeChild(dmg_text);
                this.animating = false;
            }, null, this);
        };
        Card.card_count = 0;
        Card.card_sheets_initted = false;
        return Card;
    }());
    exports.Card = Card;
    ;
});
//# sourceMappingURL=script.js.map